#![no_std]

macro_rules! import_glam {
    () => {
        #[cfg(target_arch = "spirv")]
        use spirv_std::glam;

        #[cfg(not(target_arch = "spirv"))]
        use glam;
    };
}

import_glam!();

mod transforms;
mod variations;

pub use transforms::*;
pub use variations::*;

pub fn apply_transform_f32(
    _global_id: glam::UVec3,
    transform: &TransformSpec,
    variations: &[VariationSpec],
    point_in: &glam::Vec2,
    point_out: &mut glam::Vec2,
) {
    // let mut point = transform.coefs.transform_point2(*point_in);
    let mut point = *point_in;

    let offset = transform.variation_offset as usize;
    let count = transform.variation_count as usize;
    for i in offset..count {
        point = variations[i].apply(point);
    }

    // *point_out = transform.post_coefs.transform_point2(point);
    *point_out = point;
}
