#[derive(Copy, Clone, Default, Debug, bytemuck::Pod, bytemuck::Zeroable)]
#[repr(C)]
pub struct Coefs {
    a: f32,
    b: f32,
    c: f32,
    d: f32,
    e: f32,
    f: f32,
}

impl Coefs {
    pub fn identity() -> Self {
        Coefs {
            a: 1.,
            b: 0.,
            c: 0.,
            d: 0.,
            e: 1.,
            f: 0.,
        }
    }
}

#[derive(Copy, Clone, Default, Debug, bytemuck::Pod, bytemuck::Zeroable)]
#[repr(C)]
pub struct TransformSpec {
    pub coefs: Coefs,
    pub post_coefs: Coefs,
    pub variation_offset: u32,
    pub variation_count: u32,
}
