import_glam!();

#[derive(Copy, Clone, Debug)]
#[repr(C)]
pub enum VariationKind {
    Linear,
}

// UNSAFE: I think this is fine for repr(C) enums?
unsafe impl bytemuck::Zeroable for VariationKind {}
unsafe impl bytemuck::Pod for VariationKind {}

#[derive(Copy, Clone, Debug, Default, bytemuck::Pod, bytemuck::Zeroable)]
#[repr(transparent)]
pub struct VariationParams([f32; 8]);

#[derive(Copy, Clone, Debug, bytemuck::Pod, bytemuck::Zeroable)]
#[repr(C)]
pub struct VariationSpec {
    pub kind: VariationKind,
    pub weight: f32,
    pub params: VariationParams,
}

impl VariationSpec {
    pub fn apply(&self, point: glam::Vec2) -> glam::Vec2 {
        let point = match self.kind {
            VariationKind::Linear => apply_linear(&self.params, point),
        };
        point * self.weight
    }
}

fn apply_linear(_params: &VariationParams, point: glam::Vec2) -> glam::Vec2 {
    point
}
