#![no_std]
use flare_kernel::{TransformSpec, VariationSpec};
use spirv_std::glam::{UVec3, Vec2};
use spirv_std::spirv;

#[spirv(compute(threads(1)))]
pub fn apply_transform_f32(
    #[spirv(global_invocation_id)] _global_id: UVec3,
    #[spirv(storage_buffer, descriptor_set = 0, binding = 0)] transform: &TransformSpec,
    #[spirv(storage_buffer, descriptor_set = 0, binding = 1)] variations: &[VariationSpec],
    #[spirv(uniform, descriptor_set = 0, binding = 2)] point_in: &Vec2,
    #[spirv(storage_buffer, descriptor_set = 0, binding = 3)] point_out: &mut Vec2,
) {
    flare_kernel::apply_transform_f32(_global_id, transform, variations, point_in, point_out);
}
